clear all
close all

sequenceName = 'kv2/kinect2data/000256_2014-06-02_14-59-47_260595134347_rgbf000082-resize';

opts = getOpts();
addpath('mhUtils'); % only needed for manhattan box
addpath('Utils');
data=readframeSUNRGBD(fullfile(opts.rootPath, sequenceName));

% predicted room
disp('computing ManhattanBox room estimate');
mhRoom3D = ManhattanBox(data,opts);
disp('computing ConvexBox room estimate');
cvRoom3D = ConvexBox(data, opts);

% obtaining ground truth
disp('obtaining ground truth');
gtRoom3D = data.gtCorner3D;

% rooms
disp('evaluating room estimate');
tic; iouConvex = evaluateRoom3D(data,gtRoom3D,cvRoom3D,opts); toc;
tic; iouManhattan = evaluateRoom3D(data,gtRoom3D,mhRoom3D,opts); toc;
